#ifndef __CF_CHUNK_BUFFER__
#define __CF_CHUNK_BUFFER__

#define _GNU_SOURCE

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <utime.h>
#include <pthread.h>

#include "cf_chunk_data.h"

#include "cf_config.h"


typedef struct {
	Cf_chunk_data *buffer;	/* */
	int buf_sz;		/* */
	int buf_used;		/* */
} Cf_chunk_buffer_base;

typedef Cf_chunk_buffer_base *Cf_chunk_buffer;

Cf_chunk_buffer cf_chunk_buffer_alloc();
void cf_chunk_buffer_dealloc(Cf_chunk_buffer b);
void cf_chunk_buffer_add(Cf_chunk_buffer b, int i, Cf_chunk_data d);
void cf_chunk_buffer_del(Cf_chunk_buffer b, int i);

void cf_chunk_buffer_resize(Cf_chunk_buffer b, int sz);

void cf_chunk_buffer_print(Cf_chunk_buffer b);

#define	cf_chunk_buffer_get_buffer(b,p)		(b)->buffer[p]
#define	cf_chunk_buffer_get_buf(b)		(b)->buffer
#define	cf_chunk_buffer_get_buf_sz(b)		(b)->buf_sz
#define	cf_chunk_buffer_get_buf_used(b)		(b)->buf_used

#define	cf_chunk_buffer_set_buffer(b,p,v)	cf_chunk_buffer_get_buffer(b,p) = (v)
#define	cf_chunk_buffer_set_buf(b,v)		cf_chunk_buffer_get_buf(b) = (v)
#define	cf_chunk_buffer_set_buf_sz(b,v)		cf_chunk_buffer_get_buf_sz(b) = (v)
#define	cf_chunk_buffer_set_buf_used(b,v)	cf_chunk_buffer_get_buf_used(b) = (v)

#endif
