#define _XOPEN_SOURCE	500

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "cf_chunk_data.h"
#include "cf_log.h"
#include "cf_version.h"

Cf_chunk_data cf_chunk_data_alloc(int size) {
	Cf_chunk_data ret;
	char *data;

	ret = (Cf_chunk_data) malloc(sizeof(Cf_chunk_data_base));
	data = malloc(size);
	if (!data)
		printf("Can not alloc %d bytes\n", size);

	/* Fill chunk with zeros */
	bzero(data, size);
	
	cf_chunk_data_set_data(ret, data);

	/* Set last byte pos to zero */
	cf_chunk_data_set_end(ret, 0);
	cf_chunk_data_set_dirty(ret, 0);

	return ret;
}

void cf_chunk_data_dealloc(Cf_chunk_data c) {
	free(cf_chunk_data_get_data(c));
	free(c);
}


