#ifndef __CF_CHUNK_DATA__
#define __CF_CHUNK_DATA__

#define _GNU_SOURCE

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <utime.h>
#include <pthread.h>


#include "cf_config.h"


typedef struct {
	char 		*data;		/* Data pointer */
	unsigned int 	end;		/* End of last data byte */
	char		dirty;		/* */
} Cf_chunk_data_base;

typedef Cf_chunk_data_base *Cf_chunk_data;

Cf_chunk_data cf_chunk_data_alloc(int size);
void cf_chunk_data_dealloc(Cf_chunk_data c);

#define	cf_chunk_data_get_data(c)	(c)->data
#define	cf_chunk_data_get_end(c)	(c)->end
#define	cf_chunk_data_get_dirty(c)	(c)->dirty

#define	cf_chunk_data_set_data(c,x)	cf_chunk_data_get_data(c) = x
#define	cf_chunk_data_set_end(c,x)	cf_chunk_data_get_end(c) = x
#define	cf_chunk_data_set_dirty(c,x)	cf_chunk_data_get_dirty(c) = x

#endif
