#ifndef __CF_CHUNK_HEADER__
#define __CF_CHUNK_HEADER__

#define _GNU_SOURCE

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <utime.h>
#include <pthread.h>


#include "cf_config.h"

/*

[header][chunk0,chunk1,chunk2,...,chunkn][toc]

*/

typedef struct {
	unsigned char version;
	unsigned char coding;
	unsigned int chunk_size;	/* size */
	unsigned int toc_size;		/* Number entries in toc (= #chunks) */
	unsigned int toc_offset;	/* Position toc, after last data byte */
	unsigned int data_size;		/* Uncompressed size */
} Cf_chunk_header_base;

typedef Cf_chunk_header_base *Cf_chunk_header;

Cf_chunk_header cf_chunk_header_alloc();
void cf_chunk_header_dealloc(Cf_chunk_header h);

#define cf_chunk_header_get_version(h)		(h)->version
#define cf_chunk_header_get_coding(h)		(h)->coding
#define cf_chunk_header_get_chunk_size(h)	(h)->chunk_size
#define cf_chunk_header_get_toc_size(h)		(h)->toc_size
#define cf_chunk_header_get_toc_offset(h)	(h)->toc_offset
#define cf_chunk_header_get_data_size(h)	(h)->data_size

#define	cf_chunk_header_set_version(h,x)	cf_chunk_header_get_version(h) = x
#define	cf_chunk_header_set_coding(h,x)		cf_chunk_header_get_coding(h) = x
#define	cf_chunk_header_set_chunk_size(h,x)	cf_chunk_header_get_chunk_size(h) = x
#define	cf_chunk_header_set_toc_size(h,x)	cf_chunk_header_get_toc_size(h) = x
#define	cf_chunk_header_set_toc_offset(h,x)	cf_chunk_header_get_toc_offset(h) = x
#define	cf_chunk_header_set_data_size(h,x)	cf_chunk_header_get_data_size(h) = x

#endif
