#define _XOPEN_SOURCE	500

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "cf_chunk_toc.h"
#include "cf_log.h"
#include "cf_version.h"

Cf_chunk_toc cf_chunk_toc_alloc() {
	Cf_chunk_toc ret;
	ret = (Cf_chunk_toc) malloc(sizeof(Cf_chunk_toc_base));

	cf_chunk_toc_get_entries(ret) = NULL;
	cf_chunk_toc_set_size(ret, 0);

	return ret;
}

void cf_chunk_toc_copy(Cf_chunk_toc src, Cf_chunk_toc dst) {
	int i;
	int sz = cf_chunk_toc_get_size(src);

	cf_chunk_toc_resize(dst, sz);


	for (i=0; i<sz; i++) {
		cf_chunk_toc_set_entry_size(dst, i, cf_chunk_toc_get_entry_size(src, i));
		cf_chunk_toc_set_entry_offset(dst, i, cf_chunk_toc_get_entry_offset(src, i));
	}
}

void cf_chunk_toc_dealloc(Cf_chunk_toc t) {
	free(cf_chunk_toc_get_entries(t));
	free(t);
}

void cf_chunk_toc_print (Cf_chunk_toc t) {
	int i;

	cf_printf("toc size %d\n" ,cf_chunk_toc_get_size(t));

	for (i=0; i<cf_chunk_toc_get_size(t); i++) {
		cf_printf("[%d,%d]", cf_chunk_toc_get_entry_size(t, i), cf_chunk_toc_get_entry_offset(t, i));
	}

	cf_printf("\n");

}

void cf_chunk_toc_resize(Cf_chunk_toc t, int sz) {
	Cf_toc_entry *ret;
	Cf_toc_entry *e;
	int osz;
	int i;

	osz = cf_chunk_toc_get_size(t);
	e = cf_chunk_toc_get_entries(t);

	/* The toc can shrink (deallocate entries) */
	ret = (Cf_toc_entry *) realloc(e, sz * sizeof(Cf_toc_entry));

	if ((ret == NULL) && sz) {
		cf_printf("realloc() failed in %s\n", __FUNCTION__);
	} else {
		cf_chunk_toc_get_entries(t) = ret;
	}


	for (i=osz; i<sz; i++) {
		cf_chunk_toc_set_entry_size(t, i, 0);
		cf_chunk_toc_set_entry_offset(t, i, -1);
	}

	cf_chunk_toc_set_size(t, sz);
}

