#ifndef __CF_CHUNK_TOC__
#define __CF_CHUNK_TOC__

#define _GNU_SOURCE

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <utime.h>
#include <pthread.h>


#include "cf_config.h"


typedef struct {
	int size;	/* Compressed size */
	unsigned int offset;	/* Position in the data part */
} Cf_toc_entry;

typedef struct {
	Cf_toc_entry *e;
	int sz;
} Cf_chunk_toc_base;

typedef Cf_chunk_toc_base *Cf_chunk_toc;

Cf_chunk_toc cf_chunk_toc_alloc();
void cf_chunk_toc_dealloc(Cf_chunk_toc t);
void cf_chunk_toc_copy(Cf_chunk_toc src, Cf_chunk_toc dst);

void cf_chunk_toc_resize(Cf_chunk_toc t, int sz);

#define	cf_chunk_toc_get_entries(t)		t->e
#define	cf_chunk_toc_get_size(t)		t->sz
#define cf_chunk_toc_get_entry_size(t,c)	t->e[c].size
#define cf_chunk_toc_get_entry_offset(t,c)	t->e[c].offset

#define cf_chunk_toc_set_size(t,s)		cf_chunk_toc_get_size(t) = (s)
#define cf_chunk_toc_set_entry_size(t,c,s)	cf_chunk_toc_get_entry_size(t,c) = (s)
#define cf_chunk_toc_set_entry_offset(t,c,s)	cf_chunk_toc_get_entry_offset(t,c) = (s)

void cf_chunk_toc_print(Cf_chunk_toc t);

#endif
