%{
#include <stdio.h>
#include "y.tab.h"
%}

%x	comment

%%

"//"			BEGIN(comment);
";"			BEGIN(comment);
"#"			BEGIN(comment);
<comment>[^\n]		/* ignore till end of line */;
<comment>\n		BEGIN(INITIAL);

[0-9]+                  { yylval.int_val = atoi(yytext); return NUMBER; }
chunk_max               { strcpy(yylval.str, yytext); return TOKMAX; }
chunk_size              { strcpy(yylval.str, yytext); return TOKSIZE; }
forced_scan             { strcpy(yylval.str, yytext); return TOKFORCE; }
\[                  	return TOKLBRAC;
\]                  	return TOKRBRAC; 
backend			{ strcpy(yylval.str, yytext); return TOKBACKEND; }
=			return TOKEQUAL;
,			return TOKCOMMA;
compression		{ strcpy(yylval.str, yytext); return TOKCOMPR; }
compression_threshold	{ strcpy(yylval.str, yytext); return TOKTHRESHOLD; }
exclude			{ strcpy(yylval.str, yytext); return TOKEXCL; }
writer			{ strcpy(yylval.str, yytext); return TOKWRITER; }
log			{ strcpy(yylval.str, yytext); return TOKLOG; }

[_/a-zA-Z0-9\.]+		{ strcpy(yylval.str, yytext); return TOKSTRING; }

\n                      /* ignore end of line */;
[ \t]+                  /* ignore whitespace */;

. 			printf( "Unrecognized character: %s\n", yytext );
%%
