#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

#include <sys/types.h>
#include <dirent.h>
#include <ctype.h>

#include "cf_config.h"
#include "cf_config_file.h"
/*
#include "cf_defines.h"
*/
#include "cf_log.h"

#include "y.tab.h"

YYSTYPE yylval;
extern FILE* yyin;



Cf_config_file cf_config_file_alloc() {
	Cf_config_file ret;

	ret = (Cf_config_file) malloc(sizeof(Cf_config_file_base));
	if (!ret)
		puts("cf_config_file_alloc() failed");

	cf_config_file_set_head(ret, NULL);

	return ret;
}

void cf_config_file_dealloc(Cf_config_file c) {
	free(c);
}


Cf_config cf_config_file_find(Cf_config_file c, char *m) {
	Cf_config tmp;

	tmp = cf_config_file_get_head(c);
	while (tmp) {
		if (!strcmp(cf_config_get_mountpoint(tmp), m)) {
			return tmp;
		}

		tmp = (Cf_config) cf_config_get_next(tmp);
	}

	return NULL;
}

void cf_config_file_read(Cf_config_file c) {
	/*
		First read the central configuration file (if any)
		Then read local configuration file .compFUSEd in home dir (if any)
	*/
	char home[128];

	/* Start with central dir */
	cf_config_file_parse(c, CF_CENTRAL_CONFIG);

	/* Look in home dir */
	strcpy(home, getenv("HOME"));
	strcat(home, CF_LOCAL_CONFIG);	

	cf_config_file_parse(c, home);
}

void cf_config_file_parse(Cf_config_file c, char *path) {
	FILE *fp;

	fp = fopen(path, "rt");
	if (!fp) {
		printf("Can not open config file %s\n", path);

		return;
	}

	printf("Reading config file %s\n", path);

	/* Install file pointer as input for parser */
	yyin = fp;

	/* Pass the config_file to the parser */
	parser_set_config_file(c);

	yyparse();

	fclose(fp);


	/* blahblah */
	puts("done reading configuration file.");	
}

void cf_config_file_add(Cf_config_file c, Cf_config conf) {
	Cf_config head = cf_config_file_get_head(c);

	if (head)
		cf_config_set_next(conf, head);

	cf_config_file_set_head(c, conf);
}

void yyerror(const char *str)
{
        fprintf(stderr,"error: %s\n",str);
}

int yywrap()
{
        return 1;
}
