#ifdef linux
/* For pread()/pwrite() */
#define _XOPEN_SOURCE 500
#endif

#include <fcntl.h>
#include <dirent.h>
#include <errno.h>

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "cf_file.h"


void cf_path(Cf_config c, const char *path, char *cf_path) {
	strcpy(cf_path, cf_config_get_backendpath(c));
	strcat(cf_path, path);

/*
	puts(cf_path);
*/
}


int cf_file_no_compress(Cf_config c, const char *path) {
	int i, len;
	int start, stop;
	int basename;
	char ext[5];
	int res = 0;

	/* Get extension starting from the back.

	sscanf(path, "%*[^.].%s", ext); Can not handle path names with dots.. :'(	
	
	*/
	stop = strlen(path);
	start = stop;
	while ((start > 0) && (path[start] != '/') && (path[start] != '.'))
		start--;

	/* we do not want the dot */
	basename = start+1;

	len = strlen(path+basename);
	/* No extension or too short... */
	if ((len < 2) || (len > 4))
		return 0;

	/* lower case */
	for (i=0; i<len; i++)
		ext[i] = tolower(path[basename+i]);

	ext[len]= '\0';

	i = 0;
	while ((i<cf_config_get_blacklist_size(c)) && (res == 0)) {
		res = !strcmp(ext, cf_config_get_blacklist(c)[i]);
		i++;
	}

	return res;
}
