#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <unistd.h>
#include "cf_file.h"
#include "cf_info.h"
#include "cf_scan.h"


int scan(char *path, Cf_info info) {
	printf("Scanning the entire backend directory.\n");
	printf("This may take a long time depending on your filesystem...\n");

	/* Do a verbose scan */
	cf_scan(path, info, 1); 

	printf("\n");
	printf("compFUSEd mount contains :\n");
	printf("%d files in %d directories\n", cf_info_get_files(info) , cf_info_get_dirs(info));
	printf("%.2f Mbytes data on disk\n", cf_info_get_ucomp(info) / (1024.0*1024));
	printf("%.2f Mbytes compressed data\n", cf_info_get_comp(info) / (1024.0*1024));
	printf("\n");

	return 0;
}

int main(int argc, char **argv) {
	int fd;
	char answer[5];
	char path[128];
	Cf_info info;

	cf_info_init(info);

	if (argc != 2) {
		puts("Usage: cf_fsinfo backend_path");
	
		return 1;
	}

	sprintf(path, "%s/.cf_fs_info.bin", argv[1]);

	fd = open(path, O_RDONLY);

	if (fd == -1) {
		puts("Can not read info! Can happen if the compFUSEd fs is mounted, umount first.");

		return 2;
	} else {
		cf_info_print(info);
	}

	printf("%s can do a full check, proceed? If so type 'YES': ", argv[0]);
	scanf("%s", answer);
	if (!strcmp(answer, "YES")) {
		scan(argv[1], info);
		cf_info_print(info);
	}

	close(fd);

	return 0;
}
