#ifdef linux
/* For pread()/pwrite() */
#define _XOPEN_SOURCE 500
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include "cf_log.h"
#include "cf_info.h"

void cf_info_init(Cf_info i) {

	cf_info_set_ucomp(i, 0);
	cf_info_set_comp(i, 0);
	cf_info_set_level(i, 0);
	cf_info_set_files(i, 0);
	cf_info_set_dirs(i, 0);
}


void cf_info_print(Cf_info i) {
	printf("uncompressed data: %d bytes\n", cf_info_get_ucomp(i));
	printf("compressed data  : %d bytes\n", cf_info_get_comp(i));
	printf("dir levels	 : %d\n", cf_info_get_level(i));
	printf("number of files	 : %d\n", cf_info_get_files(i));
	printf("number of dirs	 : %d\n", cf_info_get_dirs(i));
}

int cf_info_read(char *path, Cf_info ret) {
	int fd;
	int sz = sizeof(Cf_info);
	int tot;
	int res = 0;	/* No error to start with */

	fd = open(path, O_RDONLY);

        if (fd == -1) {
                perror("Can not read fs info, this is normal if it is the first time your start it.");

		res = 1; /* Signal error */
	} else {
		tot = pread(fd, ret, sz, 0);
		if (tot != sz) {
			printf("Problem reading fs info read %d bytes instead of %d\n", tot, sz);

			res = 1; /* error */
		}

	}

	/* ALWAYS delete the file, otherwise people will see strange things */
        unlink(path);

	return res;
}



void cf_info_write(char *path, Cf_info i) {
	int fd;
	int sz = sizeof(Cf_info);
	int ret;

        fd = open(path, O_WRONLY|O_CREAT, S_IRWXU);
        if (fd == -1) {
                cf_puts("WARNING: Can not write fs info");
        } else {
                ret = pwrite(fd, i, sz, 0);
		if (ret != sz) {
			printf("Problem wrinting fs info wrote %d bytes instead of %d\n", ret, sz);
		}

                close(fd);
        }

}
