#include "cf_defines.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <unistd.h>
#include "cf_file.h"
#include "cf_scan.h"
#include "cf_chunk_file.h"
#include "cf_config.h"

Cf_config c;

int cf_scan_rec(char *dir, Cf_info info, int verbose) {
	struct stat buf;
        struct dirent **namelist;
	char path[4096];
        int n;
	int ifd;
	Cf_chunk_file f;

	memset(&buf, 0, sizeof(struct stat));

        n = scandir(dir, &namelist, 0, alphasort);
    	if (n < 0)
    		perror("scandir");
   	else {
              	while(n--) {
			strcpy(path, dir);
			strcat(path, "/");
			strcat(path, namelist[n]->d_name);

			if (verbose) {
	                   	printf("\r%s", path);
				fflush(stdout);
			}

			stat(path, &buf);
			if ( S_ISREG(buf.st_mode)) {
				ifd = open(path, O_RDONLY);
				f = cf_chunk_open(ifd, c, 0);
				cf_info_set_ucomp(info, cf_info_get_ucomp(info)+ cf_chunk_size(f));
				cf_chunk_close(f);
				close(ifd);
				
				cf_info_set_files(info, cf_info_get_files(info)+1);
				cf_info_set_comp(info, cf_info_get_comp(info)+ buf.st_size);
			}

			if (strcmp(namelist[n]->d_name, "..")  && strcmp(namelist[n]->d_name, ".")) {
				if ( S_ISDIR(buf.st_mode)) {
					cf_info_set_dirs(info, cf_info_get_dirs(info)+1);
					cf_scan_rec(path, info, verbose);
				}
			}
                   	free(namelist[n]);
               	}
               	free(namelist);
       }

	return 0;
}

int cf_scan(char *path, Cf_info info, int verbose) {

	c = cf_config_alloc();

	cf_scan_rec(path, info, verbose);

	return 0;
}
