/*
	compFUSEd: compressed Filesystem in Userspace

*/

#include <stdio.h>
#include <string.h>
#include <bzlib.h>

#include "../cf_compression.h"

#define	bzip2_error		cf_error
#define	bzip2_compressor	cf_compressor
#define	bzip2_decompressor	cf_decompressor
#define	bzip2_buffersizer	cf_buffersizer

#define BZ2_MEM         1       /* Influences speed and mem */
#define BZ2_WFACTOR     0       /* Influences compression and speed */


int cf_id() {
	return CF_BZIP2;
}


void bzip2_error(int e) {
	switch(e) {
		case BZ_OK:
            		puts("BZ_OK");
			break;

		case BZ_STREAM_END:
			puts("BZ_STREAM_END");
			break;

		case BZ_RUN_OK:
			puts("BZ_RUN_OK");
			break;

		case BZ_OUTBUFF_FULL:
			puts("BZ_OUTBUFF_FULL");
			break;

		case BZ_SEQUENCE_ERROR:
			puts("BZ_SEQUENCE_ERROR");
			break;

		case BZ_DATA_ERROR:
			puts("BZ_DATA_ERROR");
			break;

		case BZ_MEM_ERROR:
			puts("Z_MEM_ERROR");
			break;

		case BZ_IO_ERROR:
			puts("BZ_IO_ERROR");
			break;

		case BZ_CONFIG_ERROR:
			puts("BZ_CONFIG_ERROR");
			break;
	}
}

int bzip2_buffersizer(int sz) {
	return sz * 15 / 10;
}

int bzip2_compressor(char *dst, int *dst_len, char *src, int src_len) {
        int r;

        r = BZ2_bzBuffToBuffCompress(dst,dst_len,src,src_len, BZ2_MEM, 0, BZ2_WFACTOR);

        if (r != BZ_OK)
                printf("ERROR: compressed %lu bytes into %lu bytes\n",
                        (long) src_len, (long) dst_len);



        return r;
}

int bzip2_decompressor(char *dst, int *dst_len, char *src, int src_len) {
        int r;

        r = BZ2_bzBuffToBuffDecompress(dst,dst_len,src,src_len, 0, 0);
        if (r != BZ_OK)
                printf("ERROR: decompressed %lu bytes into %lu bytes\n",
                        (long) src_len, (long) dst_len);

        return r;
}
