/*
	compFUSEd: compressed Filesystem in Userspace

*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <lzo2a.h>
#include <lzoutil.h>

#include "../cf_compression.h"

#define	lzo2_error		cf_error
#define	lzo2_compressor		cf_compressor
#define	lzo2_decompressor	cf_decompressor
#define	lzo2_buffersizer		cf_buffersizer

int cf_id() {
	return CF_LZO2;
}

void lzo2_error(int e) {
	switch(e) {
		case LZO_E_ERROR:
            		puts("LZO_E_ERROR");
			break;

		case LZO_E_INPUT_OVERRUN:
			puts("LZO_E_INPUT_OVERRUN");
			break;

		case LZO_E_OUTPUT_OVERRUN:
			puts("LZO_E_OUTPUT_OVERRUN");
			break;

		case LZO_E_LOOKBEHIND_OVERRUN:
			puts("LZO_E_LOOKBEHIND_OVERRUN");
			break;

		case LZO_E_EOF_NOT_FOUND:
			puts("LZO_E_EOF_NOT_FOUND");
			break;

		case LZO_E_INPUT_NOT_CONSUMED:
			puts("LZO_E_INPUT_NOT_CONSUMED");
			break;
	}
}

int lzo2_buffersizer(int sz) {
	return sz * 15 / 10;
}

int lzo2_compressor(char *dst, int *dst_len, char *src, int src_len) {
        lzo_byte *wrkmem;
        int r;

/*
	printf("lzo in %d out %d\n", src_len, *dst_len);
*/
        wrkmem = (lzo_bytep) lzo_malloc(LZO2A_999_MEM_COMPRESS);

	if (!wrkmem)
		puts("lzo_malloc() failed!");

        r = lzo2a_999_compress(src,src_len,dst,dst_len,wrkmem);
        if (r != LZO_E_OK)
                printf("ERROR: compressed %lu bytes into %lu bytes\n",
                        (long) src_len, (long) dst_len);

/*
	printf("lzo in %d out %d\n", src_len, *dst_len);
*/
	if (wrkmem)
        	lzo_free(wrkmem);

        return r;
}

int lzo2_decompressor(char *dst, int *dst_len, char *src, int src_len) {
        int r;

        r = lzo2a_decompress(src, src_len, dst, dst_len, NULL);
        if (r != LZO_E_OK)
                printf("ERROR: decompressed %lu bytes into %lu bytes\n",
                        (long) src_len, (long) dst_len);

        return r;
}
