/*
	compFUSEd: compressed Filesystem in Userspace

*/

#include <unistd.h>
#include <string.h>
#include "cf_compression.h"

#define	none_error		cf_error
#define	none_compressor		cf_compressor
#define	none_decompressor	cf_decompressor
#define	none_buffersizer	cf_buffersizer

/* none wrappers */

int cf_id() {
	return CF_NONE;
}

void none_error(int e) {
}

int none_buffersizer(int sz) {
	return sz;
}


int none_compressor(char *dst, int *dst_len, char *src, int src_len) {
	memcpy(dst, src, src_len);

	/* Sleep to fake compression time : compression 2X slower */
/*
	usleep(2*src_len);
*/
	*dst_len = src_len;

	return 0;
}

int none_decompressor(char *dst, int *dst_len, char *src, int src_len) {
	memcpy(dst, src, src_len);

	/* Sleep to fake compression time : compression 2X slower */
/*
	usleep(src_len);
*/

	*dst_len = src_len;

	return 0;
}

