/*
	compFUSEd: compressed Filesystem in Userspace

*/

#include <stdio.h>
#include <string.h>
#include <zlib.h>

#include "../cf_compression.h"

#define	zlib_error		cf_error
#define	zlib_compressor		cf_compressor
#define	zlib_decompressor	cf_decompressor
#define	zlib_buffersizer	cf_buffersizer

/* ZLIB wrappers */

int cf_id() {
	return CF_ZLIB;
}

/* these are not needed as the signature is the same that of the wrappers */

void zlib_error(int e) {
	switch(e) {
		case Z_OK:
            		puts("Z_OK");
			break;

		case Z_STREAM_END:
			puts("Z_STREAM_END");
			break;

		case Z_NEED_DICT:
			puts("Z_NEED_DICT");
			break;

		case Z_ERRNO:
			puts("Z_ERRNO");
			break;

		case Z_STREAM_ERROR:
			puts("Z_STREAM_ERROR");
			break;

		case Z_DATA_ERROR:
			puts("Z_DATA_ERROR");
			break;

		case Z_MEM_ERROR:
			puts("Z_MEM_ERROR");
			break;

		case Z_BUF_ERROR:
			puts("Z_BUF_ERROR");
			break;

		case Z_VERSION_ERROR:
			puts("Z_VERSION_ERROR");
			break;
	}
}

int zlib_buffersizer(int in) {
	return compressBound(in);
}

int zlib_compressor(char *dst, int *dst_len, char *src, int src_len) {
	int ret;

	ret = compress(dst, (unsigned long *)dst_len, src, (unsigned long)src_len);

        if (ret != Z_OK)
                printf("ERROR: decompressed %lu bytes into %lu bytes\n",
                        (long) src_len, (long) dst_len);

	return ret;
}

int zlib_decompressor(char *dst, int *dst_len, char *src, int src_len) {
	int ret;

	ret =  uncompress(dst, (unsigned long *)dst_len, src, (unsigned long)src_len);

        if (ret != Z_OK)
                printf("ERROR: decompressed %lu bytes into %lu bytes\n",
                        (long) src_len, (long) dst_len);

	return ret;
}
